
c
c Output of synthvit and synth
c

      parameter (nstmax=1000,nt=10,npoints=2**nt)
      dimension t(10000),u(250,250),sismo(5000)
      complex cdatu(npoints),cdatv(npoints),cdatw(npoints)
      real f(npoints),res(npoints)
      pi=4.*atan(1.)
      print *,'pi = ',pi
c
c     initialisation a zero du tableau de donnees
c
      print *,' Fourier de ',npoints,' points'
      do i=1,npoints
         sismo(i)=0.
         cdatu(i)=(0.,0.)
      enddo
c
      print *,"le nombre total de points  = ",n
c     
      open(22,file='../input.dat')
      read(22,*)nxt,nyt,nzt
      read(22,*)npt
      read(22,*)dh
      read(22,*)dt
      tmax=float(npt)*dt
      read(22,*)nxc
      read(22,*)nyc
      read(22,*)nzc
      beta=3520.
      dx=200.
      dt_red=dt*5.
      amom=dh*dh*3.e+10
      nt0=int(tmax/dt)
      nt_sections=nt0/5
      print *,'tmax, dt, dh, nt0 =',tmax,dt,dh,nt0
      print *,'enter angle theta (0 Is vertical)'
      read (*,*) angle
      print *,'enter angle phi (0 Is mode 2)'
      read (*,*) azimut
      phi=pi*azimut/180.
      theta=pi*angle/180.
      print *,angle,'->',theta,'  ',azimut,' -> ',phi
c      theta=0.
      directiv=dx*sin(theta)/(dt_red*beta)
      print *,' direct = ', directiv
      call system('gunzip -dc sliprate_full.res.gz>rate.tmp')
      open(57,file='rate.tmp')
      open(81,file='farfield.res')
      do i=1,npoints
         sismo(i)=0
      enddo
      open(43,file='isochrones.dat')
      open(44,file='sliprate.dat')
      do i=1,nt_sections
        if(mod(i,10).eq.1)print *,'i = ',i
        do k=1,nzt
           read(57,'(1g12.4)') (u(ii,k),ii=1,nxt)
        enddo
        do j=1,nxt
           x_red=float(j-nxc)
           do k=1,nzt
              z_red=float(k-nzc)
              rad=sqrt(x_red**2+z_red**2)
              phi2=atan2(z_red,x_red)
              dire=directiv*cos(phi2-phi)
              i_red=i-int(rad*dire)
              if(i.eq.1)then
                  write(43,*)i_red
              endif
              if(i.eq.2*nxt/5)then
                  write(44,*)u(j,k)
              endif
              if(i_red.gt.1)then
                 sismo(i_red)=sismo(i_red)+u(j,k)
              endif     
           enddo
           if(i.eq.1) write(43,'()')
           if(i.eq.2*nxt/5) write(44,'()')
         enddo
      enddo
c     
c copie f(t) dans la partie reelle de cdat
c   
  
      print *,' Calculo de TdF '
      print *,'nt_sections, dt_red, npoints = ',nt_sections,dt_red,
     $           npoints
      do i=1,nt_sections
         vel=0     
         if(i.gt.1)vel=sismo(i)-sismo(i-1)
         write(81,*)float(i-1)*dt_red,sismo(i)*amom,vel*amom        
c         write(81,*)float(i-1)*dt_red,sismo(i),vel        
         cdatu(i)=cmplx(sismo(i),0.)
      enddo
c     
      call fourt(cdatu,nt,-1)
      do i=1,npoints
         cdatu(i)=cdatu(i)*amom*dt_red
c         cdatu(i)=cdatu(i)*dt_red
      enddo
      open(8,file="fft.dat")
      Total=dt_red*npoints/2
      do i=1,npoints/2+1
           write(8,'(4g14.3)')float(i-1)/Total,cabs(cdatu(i))
      enddo
      close(8)
      call system('farfield.plt')
      call system('ff_fft_ps.plt')
      call system('isochrones.plt')
      call system('rm -f rate.tmp')
      end 
c     
c     
c=======================================================================
c     Transformee de fourier numerique
c     a est un tableau de complexes
c=======================================================================
c---  <   fourt + fwrt    ete 83   >
c---  <   compatible fourt  >
c     
      subroutine fourt(a,m,isgn)
      dimension a(1)
      call fwurt(a,a(2),m,isgn)
      return
      end
c     
c=======================================================================
c---  <   utilitaire de fourt ete 83   >
c     Ce programme qui n'utilise pas de complexes 
c=======================================================================
c     
      subroutine fwurt(ar,ai,m,isgn)
      real signo
      dimension ar(1),ai(1)
      signo=float(isgn)
      n=2**m
      n2=2*n
      nv2=n/2
      nm1=n-1
      j=1
      do  i=1,nm1
         if (i.ge.j) go to 5
         ii=2*i-1
         jj=2*j-1
         tr=ar(jj)
         ti=ai(jj)
         ar(jj)=ar(ii)
         ai(jj)=ai(ii)
         ar(ii)=tr
         ai(ii)=ti
 5       k=nv2
 6       if (k.ge.j) go to 7
         j=j-k
         k=k/2
         go to 6
 7       j=j+k
      enddo
      pi=3.14159265358979*signo
      do i=1,n2,4
         ip=i+2
         tr=ar(ip)
         ti=ai(ip)
         ar(ip)=ar(i)-tr
         ai(ip)=ai(i)-ti
         ar(i)=ar(i)+tr
 11      ai(i)=ai(i)+ti
      enddo
      do  l=2,m
         le=2**l
         le1=le/2
         le2=2*le
         wr=cos(pi/le1)
         wi=sin(pi/le1)
         ur=wr
         ui=wi
         do i=1,n2,le2
            ip=i+le
            tr=ar(ip)
            ti=ai(ip)
            ar(ip)=ar(i)-tr
            ai(ip)=ai(i)-ti
            ar(i)=ar(i)+tr
 12         ai(i)=ai(i)+ti
         enddo
         do  j=3,le,2
            do  i=j,n2,le2
               ip=i+le
               tr=ar(ip)*ur-ai(ip)*ui
               ti=ar(ip)*ui+ai(ip)*ur
               ar(ip)=ar(i)-tr
               ai(ip)=ai(i)-ti
               ar(i)=ar(i)+tr
               ai(i)=ai(i)+ti
            enddo
            t=ur
            ur=ur*wr-ui*wi
          ui=t*wi+ui*wr
         enddo
      enddo
      return
      end

